package fr.ippon.geohipster.service;

import fr.ippon.geohipster.domain.Geocity;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

/**
 * Service Interface for managing Geocity.
 */
public interface GeocityService {

    /**
     * Save a geocity.
     *
     * @param geocity the entity to save
     * @return the persisted entity
     */
    Geocity save(Geocity geocity);

    /**
     *  Get all the geocities.
     *
     *  @param pageable the pagination information
     *  @return the list of entities
     */
    Page<Geocity> findAll(Pageable pageable);

    /**
     *  Get the "id" geocity.
     *
     *  @param id the id of the entity
     *  @return the entity
     */
    Geocity findOne(Long id);

    /**
     *  Delete the "id" geocity.
     *
     *  @param id the id of the entity
     */
    void delete(Long id);
}
