import { NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { RouterModule } from '@angular/router';

import { GeohipsterSharedModule } from '../../shared';
import {
    GeocityService,
    GeocityPopupService,
    GeocityComponent,
    GeocityDetailComponent,
    GeocityDialogComponent,
    GeocityPopupComponent,
    GeocityDeletePopupComponent,
    GeocityDeleteDialogComponent,
    geocityRoute,
    geocityPopupRoute,
} from './';

const ENTITY_STATES = [
    ...geocityRoute,
    ...geocityPopupRoute,
];

@NgModule({
    imports: [
        GeohipsterSharedModule,
        RouterModule.forRoot(ENTITY_STATES, { useHash: true })
    ],
    declarations: [
        GeocityComponent,
        GeocityDetailComponent,
        GeocityDialogComponent,
        GeocityDeleteDialogComponent,
        GeocityPopupComponent,
        GeocityDeletePopupComponent,
    ],
    entryComponents: [
        GeocityComponent,
        GeocityDialogComponent,
        GeocityPopupComponent,
        GeocityDeleteDialogComponent,
        GeocityDeletePopupComponent,
    ],
    providers: [
        GeocityService,
        GeocityPopupService,
    ],
    schemas: [CUSTOM_ELEMENTS_SCHEMA]
})
export class GeohipsterGeocityModule {}
