/* tslint:disable max-line-length */
import { ComponentFixture, TestBed, async, inject } from '@angular/core/testing';
import { OnInit } from '@angular/core';
import { DatePipe } from '@angular/common';
import { ActivatedRoute } from '@angular/router';
import { Observable } from 'rxjs/Rx';
import { JhiDateUtils, JhiDataUtils, JhiEventManager } from 'ng-jhipster';
import { GeohipsterTestModule } from '../../../test.module';
import { MockActivatedRoute } from '../../../helpers/mock-route.service';
import { GeocityDetailComponent } from '../../../../../../main/webapp/app/entities/geocity/geocity-detail.component';
import { GeocityService } from '../../../../../../main/webapp/app/entities/geocity/geocity.service';
import { Geocity } from '../../../../../../main/webapp/app/entities/geocity/geocity.model';

describe('Component Tests', () => {

    describe('Geocity Management Detail Component', () => {
        let comp: GeocityDetailComponent;
        let fixture: ComponentFixture<GeocityDetailComponent>;
        let service: GeocityService;

        beforeEach(async(() => {
            TestBed.configureTestingModule({
                imports: [GeohipsterTestModule],
                declarations: [GeocityDetailComponent],
                providers: [
                    JhiDateUtils,
                    JhiDataUtils,
                    DatePipe,
                    {
                        provide: ActivatedRoute,
                        useValue: new MockActivatedRoute({id: 123})
                    },
                    GeocityService,
                    JhiEventManager
                ]
            }).overrideTemplate(GeocityDetailComponent, '')
            .compileComponents();
        }));

        beforeEach(() => {
            fixture = TestBed.createComponent(GeocityDetailComponent);
            comp = fixture.componentInstance;
            service = fixture.debugElement.injector.get(GeocityService);
        });

        describe('OnInit', () => {
            it('Should call load all on init', () => {
            // GIVEN

            spyOn(service, 'find').and.returnValue(Observable.of(new Geocity(10)));

            // WHEN
            comp.ngOnInit();

            // THEN
            expect(service.find).toHaveBeenCalledWith(123);
            expect(comp.geocity).toEqual(jasmine.objectContaining({id: 10}));
            });
        });
    });

});
